This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 630204 - Review Request: ghc-mtlparse - Haskell mtlparse library
Review Request: ghc-mtlparse - Haskell mtlparse library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Narasimhan
Fedora Extras Quality Assurance
:
: 630202 630203 (view as bug list)
Depends On:
Blocks: ghc-regexpr
  Show dependency treegraph
 
Reported: 2010-09-03 21:55 EDT by Ben Boeckel
Modified: 2011-02-07 15:02 EST (History)
5 users (show)

See Also:
Fixed In Version: ghc-mtlparse-0.1.1-1.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-02-07 14:58:33 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
lakshminaras2002: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)
patch_to_fix_summary_and_description (374 bytes, patch)
2010-12-18 07:55 EST, Narasimhan
no flags Details | Diff

  None (edit)
Description Ben Boeckel 2010-09-03 21:55:59 EDT
Spec: http://benboeckel.net/packaging/ghc-mtlparse/ghc-mtlparse
SRPM: http://benboeckel.net/packaging/ghc-mtlparse/ghc-mtlparse-0.0.1-1.fc14.src.rpm
Description:
An mtlparse library for Haskell.

% lintmock fedora-14-x86_64-bb
ghc-mtlparse.src: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-mtlparse.src: W: strange-permission mtlparse-0.0.1.tar.gz 0640L
ghc-mtlparse.src: W: strange-permission ghc-mtlparse.spec 0640L
ghc-mtlparse.x86_64: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-mtlparse-devel.x86_64: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-mtlparse-prof.x86_64: E: devel-dependency ghc-mtlparse-devel
ghc-mtlparse-prof.x86_64: W: no-documentation
ghc-mtlparse-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.12.3/mtlparse-0.0.1/libHSmtlparse-0.0.1_p.a
4 packages and 0 specfiles checked; 1 errors, 7 warnings.
Comment 1 Ben Boeckel 2010-09-03 22:01:45 EDT
*** Bug 630203 has been marked as a duplicate of this bug. ***
Comment 2 Ben Boeckel 2010-09-03 22:01:49 EDT
*** Bug 630202 has been marked as a duplicate of this bug. ***
Comment 3 Thomas Moschny 2010-09-26 05:23:50 EDT
Some remarks prior to a full review:

* Seems https://fedoraproject.org/wiki/Packaging:Haskell is out of date. It does not mention %ghc_lib_build, %ghc_lib_install or %ghc_lib_package, and has broken links to cvs.fedoraproject.org and also broken links to git.fedorahosted.org. Nevertheless, the specfile is auto-generated, and thus mostly identical to spectemplate-ghc-lib.spec, so I'll assume it's ok.

* The aforementioned wiki page says: "When packaging things out of Hackage or other sources, you may find that the summary or description is incomplete or lacks detail. Please try to include an appropriate summary and adequate description for Fedora of the library or program in the package so users will know what it does." This is clearly missing here. Not even all three lines of summary present in Hackage are included in the summary, but even those are a bit thin.

* rpmlint says: ghc-mtlparse.x86_64: W: executable-stack /usr/lib64/ghc-6.12.1/mtlparse-0.0.1/libHSmtlparse-0.0.1-ghc6.12.1.so - Could that cause any problems, e.g. with selinux?
Comment 4 Jens Petersen 2010-09-28 07:07:23 EDT
(In reply to comment #3)
> * Seems https://fedoraproject.org/wiki/Packaging:Haskell is out of date.

Yes - I have started revising them:
https://fedoraproject.org/wiki/PackagingDrafts/Haskell
but not finished yet.
Comment 5 Ben Boeckel 2010-10-31 12:22:24 EDT
Spec: http://benboeckel.net/packaging/ghc-mtlparse/ghc-mtlparse
SRPM: http://benboeckel.net/packaging/ghc-mtlparse/ghc-mtlparse-0.1.1-1.fc14.src.rpm

% lintmock fedora-14-x86_64-bb
ghc-mtlparse.src: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-mtlparse.src: W: strange-permission mtlparse-0.1.1.tar.gz 0640L
ghc-mtlparse.src: W: strange-permission ghc-mtlparse.spec 0640L
ghc-mtlparse.x86_64: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-mtlparse-devel.x86_64: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
ghc-mtlparse-prof.x86_64: E: devel-dependency ghc-mtlparse-devel
ghc-mtlparse-prof.x86_64: W: no-documentation
ghc-mtlparse-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.12.3/mtlparse-0.1.1/libHSmtlparse-0.1.1_p.a
4 packages and 0 specfiles checked; 1 errors, 7 warnings.
Comment 6 Thomas Moschny 2010-11-17 10:45:06 EST
From my earlier comment:

[...] "Please try to include an appropriate summary and adequate description for Fedora of the library or program in the package so users will know what it does." This is clearly missing here. Not even all three lines of summary present in Hackage are included in the summary, and even those are a bit thin.
Comment 7 Narasimhan 2010-12-14 10:33:15 EST
Here's my review.

[+]MUST: rpmlint must be run on every package. The output should be posted in the review.
rpmlint  -i ghc-mtlparse*.rpm ghc-mtlparse.spec 
ghc-mtlparse.src: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
The value of this tag appears to be misspelled. Please double-check.

ghc-mtlparse.src: W: strange-permission mtlparse-0.1.1.tar.gz 0640L
A file that you listed to include in your package has strange permissions.
Usually, a file should have 0644 permissions.

ghc-mtlparse.src: W: strange-permission ghc-mtlparse.spec 0640L
A file that you listed to include in your package has strange permissions.
Usually, a file should have 0644 permissions.

ghc-mtlparse.x86_64: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
The value of this tag appears to be misspelled. Please double-check.

ghc-mtlparse-devel.x86_64: W: spelling-error Summary(en_US) Haskell -> Gaskell, Gaitskell, Skellum
The value of this tag appears to be misspelled. Please double-check.

ghc-mtlparse-prof.x86_64: E: devel-dependency ghc-mtlparse-devel
Your package has a dependency on a devel package but it's not a devel package
itself.

ghc-mtlparse-prof.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

ghc-mtlparse-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.12.3/mtlparse-0.1.1/libHSmtlparse-0.1.1_p.a
A development file (usually source code) is located in a non-devel package. If
you want to include source code in your package, be sure to create a
development package.

4 packages and 1 specfiles checked; 1 errors, 7 warnings.

[+]MUST: The package must be named according to the Package Naming Guidelines.
[+]MUST: The spec file name must match the base package %{name}, in the format %{name}.spec
[+]MUST: The package must meet the Packaging Guidelines.
        Naming-Yes
        Version-release - Matches
        License - OK, only mentioned in the cabal file
        No prebuilt external bits - OK
        Spec legibity - OK
        Package template - OK
        Arch support - OK
        Libexecdir - OK
        rpmlint - yes
        changelogs - OK
        Source url tag  - OK, validated.
        Buildroot is ignored - present anyway. OK
        %clean is ignored - present anyway. OK
        Build Requires list - OK
        Summary and description - OK
        API documentation - OK,present in devel package

[+]MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[+]MUST: The License field in the package spec file must match the actual license.
[+]MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+]MUST: The spec file must be written in American English.
[+]MUST: The spec file for the package MUST be legible.
[+]MUST: The sources used to build the package must match the upstream source,as provided in the spec URL. Reviewers should use md5sum for this task.

[~/ghc-mtlparse-0.1.1-1.fc14.src]$ md5sum mtlparse-0.1.1.tar.gz 
f70a187b397aed658321029cffa3513c  mtlparse-0.1.1.tar.gz

[~/ghc-mtlparse-0.1.1-1.fc14.src] md5sum ~/Downloads/mtlparse-0.1.1.tar.gz 
f70a187b397aed658321029cffa3513c  ~/Downloads/mtlparse-0.1.1.tar.gz

[+]MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
Built on x86_64
[+]MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in
ExcludeArch.
[+]MUST: All build dependencies must be listed in BuildRequires.
[NA]MUST: The spec file MUST handle locales properly using the %find_lang macro
[NA]MUST: Packages stores shared library files must call ldconfig in %post and %postun.
[+]MUST: Packages must NOT bundle copies of system libraries.
Checked with rpmquery --list
[NA]MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review.
[+]MUST: A package must own all directories that it creates.
Checked with rpmquery --whatprovides.
[+]MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
[+]MUST: Permissions on files must be set properly.
[+]MUST: Each package must consistently use macros.
[+]MUST: The package must contain code, or permissable content.
[+]MUST: Large documentation files must go in a -doc subpackage.
[+]MUST: If a package includes something as %doc, it must not affect the runtime of the application.
Checked with ls -lR
[+]MUST: Header files must be in a -devel package.
[NA]MUST: Static libraries must be in a -static package.
[NA]MUST: If a package contains library files with a suffix (e.g.libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[+]MUST: devel packages must require the base package using a fully versioned dependency: Requires: {name} = %{version}-%{release}
rpm -e ghc-mtlparse-devel
error: Failed dependencies:
	ghc-mtlparse-devel = 0.1.1-1.fc14 is needed by (installed) ghc-mtlparse-prof-0.1.1-1.fc14.x86_64
rpm -e ghc-mtlparse
error: Failed dependencies:
	ghc-mtlparse = 0.1.1-1.fc14 is needed by (installed) ghc-mtlparse-devel-0.1.1-1.fc14.x86_64

[NA]MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[NA]MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section
[+]MUST: Packages must not own files or directories already owned by other packages.
Checked with rpmquery --list
[+]MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+]MUST: All filenames in rpm packages must be valid UTF-8.

Should items
[+]SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[+]SHOULD: The reviewer should test that the package functions as described.
Installed the package. Compiled and run a small program that imports Text.ParserCombinators.MTLParse.
[+]SHOULD: If scriptlets are used, those scriptlets must be sane.

cabal2spec-diff is OK.

APPROVED.
Comment 8 Ben Boeckel 2010-12-17 23:27:35 EST
New Package CVS Request
=======================
Package Name: ghc-mtlparse
Short Description: Haskell mtlparse library
Owners: mathstuf
Branches: F-13 F-14
InitialCC: haskell-sig
Comment 9 Thomas Moschny 2010-12-18 05:47:52 EST
Honestly, is it really that hard to put a meaningful description in the spec file?
Comment 10 Narasimhan 2010-12-18 07:55:28 EST
Created attachment 469509 [details]
patch_to_fix_summary_and_description
Comment 11 Ben Boeckel 2010-12-18 10:24:23 EST
Ah, oops. Missed `cabal info` on this one and the '!' flags in mutt got missed on the emails, sorry.

Updated spec file:

Spec: http://benboeckel.net/packaging/ghc-mtlparse/ghc-mtlparse.spec
Comment 12 Jason Tibbitts 2010-12-21 11:00:14 EST
Git done (by process-git-requests).
Comment 13 Fedora Update System 2011-01-29 12:51:15 EST
ghc-mtlparse-0.1.1-1.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/ghc-mtlparse-0.1.1-1.fc13
Comment 14 Fedora Update System 2011-01-29 12:51:23 EST
ghc-mtlparse-0.1.1-1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/ghc-mtlparse-0.1.1-1.fc14
Comment 15 Fedora Update System 2011-01-30 14:47:51 EST
ghc-mtlparse-0.1.1-1.fc13 has been pushed to the Fedora 13 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update ghc-mtlparse'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/ghc-mtlparse-0.1.1-1.fc13
Comment 16 Fedora Update System 2011-02-07 14:58:29 EST
ghc-mtlparse-0.1.1-1.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 17 Fedora Update System 2011-02-07 15:01:58 EST
ghc-mtlparse-0.1.1-1.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.